import { jsxs, jsx } from "react/jsx-runtime";
import { Flex, Box, Typography } from "@strapi/design-system";
import { ap as getStageColorByHex, aq as STAGE_COLOR_DEFAULT, a0 as getDisplayName } from "./index-Sd8uo7mE-B6VoGXRI.mjs";
import { useIntl } from "react-intl";
const ReviewWorkflowsStageEE = ({
  color = STAGE_COLOR_DEFAULT,
  name
}) => {
  const { themeColorName } = getStageColorByHex(color) ?? {};
  return /* @__PURE__ */ jsxs(Flex, { alignItems: "center", gap: 2, maxWidth: `${300 / 16}rem`, children: [
    /* @__PURE__ */ jsx(
      Box,
      {
        height: 2,
        background: color,
        borderColor: themeColorName === "neutral0" ? "neutral150" : void 0,
        hasRadius: true,
        shrink: 0,
        width: 2
      }
    ),
    /* @__PURE__ */ jsx(Typography, { fontWeight: "regular", textColor: "neutral700", ellipsis: true, children: name })
  ] });
};
const ReviewWorkflowsAssigneeEE = ({ user }) => {
  const { formatMessage } = useIntl();
  return /* @__PURE__ */ jsx(Typography, { textColor: "neutral800", children: getDisplayName(user, formatMessage) });
};
export {
  ReviewWorkflowsAssigneeEE,
  ReviewWorkflowsStageEE
};
//# sourceMappingURL=ReviewWorkflowsColumn-BdkHPnDo-FKss4ScT.mjs.map
