"use strict";
const React = require("react");
const indexSd8uo7mE = require("./index-Sd8uo7mE-t07iYafJ.js");
function _interopNamespace(e) {
  if (e && e.__esModule)
    return e;
  const n = Object.create(null, { [Symbol.toStringTag]: { value: "Module" } });
  if (e) {
    for (const k in e) {
      if (k !== "default") {
        const d = Object.getOwnPropertyDescriptor(e, k);
        Object.defineProperty(n, k, d.get ? d : {
          enumerable: true,
          get: () => e[k]
        });
      }
    }
  }
  n.default = e;
  return Object.freeze(n);
}
const React__namespace = /* @__PURE__ */ _interopNamespace(React);
const useSyncRbac = (collectionTypeUID, query, containerName = "listView") => {
  const [isLoading, setIsLoading] = React__namespace.useState(true);
  const dispatch = indexSd8uo7mE.useTypedDispatch();
  const userPermissions = indexSd8uo7mE.useAuth("useSyncRbac", (state) => state.permissions);
  const relatedPermissions = React__namespace.useMemo(() => {
    const contentTypePermissions = userPermissions.filter(
      (permission) => permission.subject === collectionTypeUID
    );
    return contentTypePermissions.reduce(
      (acc, permission) => ({ ...acc, [permission.action]: [permission] }),
      {}
    );
  }, [collectionTypeUID, userPermissions]);
  React__namespace.useEffect(() => {
    setIsLoading(true);
    if (relatedPermissions) {
      dispatch(
        indexSd8uo7mE.setPermissions({
          permissions: relatedPermissions,
          __meta__: {
            plugins: query ? query.plugins : void 0,
            containerName
          }
        })
      );
    }
    setIsLoading(false);
    return () => {
      dispatch(indexSd8uo7mE.resetPermissions());
    };
  }, [relatedPermissions, dispatch, query, containerName]);
  const permissions = indexSd8uo7mE.useTypedSelector((state) => state["content-manager"].rbac.permissions);
  const isPermissionMismatch = permissions && permissions.some((permission) => permission.subject !== collectionTypeUID) ? true : false;
  return {
    isLoading,
    isError: !isLoading && isPermissionMismatch,
    permissions
  };
};
exports.useSyncRbac = useSyncRbac;
//# sourceMappingURL=useSyncRbac-Od0wrAnD-U2WlPjap.js.map
